# Lightning Strike Events
execute as @e[type=minecraft:lightning_bolt] at @s run function charlottebuff:lightning/strike_event

# Small Fireball Effects
execute as @e[type=minecraft:small_fireball] at @s run function charlottebuff:small_fireball/area_effect

# Deepslate Ore Spawn Bonus
execute as @e[tag=!charlottebuff.processed_for_held_deepslate_ore_at_spawn,type=#charlottebuff:can_spawn_holding_deepslate_ores,predicate=charlottebuff:can_spawn_with_held_deepslate_ore] run function charlottebuff:spawn_bonus/give_random_deepslate_ore
tag @e[tag=!charlottebuff.processed_for_held_deepslate_ore_at_spawn,type=#charlottebuff:can_spawn_holding_deepslate_ores] add charlottebuff.processed_for_held_deepslate_ore_at_spawn

# Sparkling Creeper Spawn Bonus
execute as @e[tag=!charlottebuff.processed_for_sparkling_at_spawn,type=minecraft:creeper,predicate=charlottebuff:can_spawn_sparkling] run function charlottebuff:spawn_bonus/make_sparkling
tag @e[tag=!charlottebuff.processed_for_sparkling_at_spawn,type=minecraft:creeper] add charlottebuff.processed_for_sparkling_at_spawn
execute as @e[tag=charlottebuff.sparkling] at @s run particle minecraft:electric_spark ~ ~0.85 ~ 0.25 0.45 0.25 0.1 1 force

# Gilded Magma Cube Spawn Bonus
execute as @e[tag=!charlottebuff.processed_for_gilded_at_spawn,type=minecraft:magma_cube,predicate=charlottebuff:can_spawn_gilded] run function charlottebuff:spawn_bonus/make_gilded
tag @e[tag=!charlottebuff.processed_for_gilded_at_spawn,type=minecraft:magma_cube] add charlottebuff.processed_for_gilded_at_spawn
execute as @e[tag=charlottebuff.gilded] if predicate charlottebuff:chance/coin_toss at @s anchored eyes positioned ^ ^ ^ run particle minecraft:totem_of_undying ~ ~ ~ 0 0 0 0.3 2 force
execute as @e[type=minecraft:magma_cube,tag=!charlottebuff.gilded,nbt={CustomName:'{"translate":"entity.charlottebuff.gilded_magma_cube"}'}] run data remove entity @s CustomName

# Lucky Witch Spawn Bonus
execute as @e[tag=!charlottebuff.processed_for_lucky_at_spawn,type=minecraft:witch,predicate=charlottebuff:can_spawn_lucky] run function charlottebuff:spawn_bonus/make_lucky
tag @e[tag=!charlottebuff.processed_for_lucky_at_spawn,type=minecraft:witch] add charlottebuff.processed_for_lucky_at_spawn
execute as @e[tag=charlottebuff.lucky] if predicate charlottebuff:chance/1d4 at @s run particle minecraft:happy_villager ~ ~1.3 ~ 0.3 0.5 0.3 0.2 2 force

# Arms for Armor Stands
execute as @e[type=minecraft:armor_stand,nbt={ShowArms:0b,Invisible:0b},nbt=!{Marker:1b}] at @s if entity @e[predicate=charlottebuff:is_dropped_stick,distance=..0.75] run function charlottebuff:armor_stand/show_arms

# Wandering Trader Loot Crate
execute as @e[tag=!charlottebuff.processed_for_loot_crate,type=minecraft:wandering_trader] if predicate charlottebuff:wandering_trader_loot_crate_chance run function charlottebuff:loot_crate/add_trade
tag @e[tag=!charlottebuff.processed_for_loot_crate,type=minecraft:wandering_trader] add charlottebuff.processed_for_loot_crate

# Shrinking Armor Stands in Cauldrons
execute as @e[predicate=charlottebuff:is_boilable_armor_stand] at @s run function charlottebuff:armor_stand/boil
execute as @e[predicate=charlottebuff:is_dropped_armor_stand,scores={charlottebuff.cauldron_boiling=600..}] at @s run function charlottebuff:armor_stand/shrink

# Standing on Cacti
scoreboard players add @a[predicate=charlottebuff:standing_on_cactus] charlottebuff.time_standing_on_cactus 1
scoreboard players set @a[scores={charlottebuff.time_standing_on_cactus=1..},predicate=!charlottebuff:standing_on_cactus] charlottebuff.time_standing_on_cactus 0

# Being in the Void
scoreboard players add @a[predicate=charlottebuff:in_void] charlottebuff.time_in_void 1
scoreboard players set @a[scores={charlottebuff.time_in_void=1..},predicate=!charlottebuff:in_void] charlottebuff.time_in_void 0

# Void Particles
execute as @a[predicate=charlottebuff:in_void,gamemode=!spectator] run function charlottebuff:void/particle

# "On A Rail" Advancement
execute as @a[predicate=charlottebuff:riding_minecart,advancements={charlottebuff:misc/on_a_rail=false}] run function charlottebuff:rail/calculate_distance_from_last_minecart_enter_squared

# Generating Ambrosium Shards
scoreboard players add @a[predicate=charlottebuff:close_to_aether,advancements={charlottebuff:misc/build_aether_portal=true},gamemode=!spectator] charlottebuff.ambrosium_shard_generation_timer 1
scoreboard players add @a[predicate=charlottebuff:close_to_aether,advancements={charlottebuff:misc/build_aether_portal=true}] charlottebuff.aether_saturation 1
scoreboard players remove @a[predicate=!charlottebuff:close_to_aether,scores={charlottebuff.aether_saturation=1..},predicate=charlottebuff:aether_saturation_decay_frequency] charlottebuff.aether_saturation 1
execute as @a[scores={charlottebuff.ambrosium_shard_generation_timer=200..}] at @s run function charlottebuff:aether/give_ambrosium_shard
execute as @a[predicate=charlottebuff:close_to_aether,advancements={charlottebuff:misc/build_aether_portal=true},gamemode=!spectator] if predicate charlottebuff:chance/1d8 at @s anchored eyes positioned ^ ^ ^ run particle minecraft:end_rod ~ ~ ~ 0.75 0.5 0.75 0.1 2 force